unit hiGlobalVarEx;

interface

uses Kol,Share,Debug;

type
  ThiGlobalVarEx = class(TDebug)
   private
    FName:string;
    GData:PData;

    procedure SetData(Data:TData);
    procedure SetName(const Value:string);
    procedure AddName(const Name:string);
   public
    _event_onValue:THI_Event;
    _data_Data:THI_Event;
    procedure _work_doValue(var _Data:TData; Index:word);
    procedure _work_doName(var _Data:TData; Index:word);
    procedure _var_Var(var _Data:TData; Index:word);
    property _prop_Name:string write SetName;
    property _prop_Data:TData write SetData;
  end;

var
  NList:PStrListEx;

  function ForceGVar(const Name:string):PData;
  function Find(const Name:string;var i:integer):boolean;

implementation

function ForceGVar(const Name:string):PData;
var i:integer;
begin
  if Find(Name,i) then
    Result := PData(NList.Objects[i])
    //_debug('ok')
  else
   begin  //_debug('ok_');
    new(Result);      // delete!!!
    dtNull(Result^);
    NList.add(Name);
    NList.Objects[NList.Count-1] := cardinal(Result);
   end;
end;

function Find( const Name:string;var i:integer):boolean;
begin
  if NList = nil then
    NList := NewStrListEx;
  i := 0;
  while i < NList.Count do
   if StrIComp(PChar(NList.Items[i]),PChar(Name)) = 0 then
    Break
   else inc(i);
  Result := i < NList.Count;
end;

procedure ThiGlobalVarEx.SetName;
var i:integer;
begin
  FName := LowerCase(Value);
  //_debug(FName + ':' + NList.Text);

  if Find(FName,i) then
   begin
    GData := PData(NList.Objects[i]);
   end
  else if FName <> '' then
    AddName(FName);
end;

procedure ThiGlobalVarEx.AddName;
begin
   new(GData);
   dtNull(GData^);
   NList.add(Name);
   NList.Objects[NList.Count-1] := cardinal(GData);
end;

procedure ThiGlobalVarEx.SetData;
var dt:TData;
begin
   if not _IsNull(Data) then
      _work_doValue(Data,0);
end;

procedure ThiGlobalVarEx._work_doValue;
var dt:TData;
begin
  dtNull(dt);
  if GData <> nil then
    begin
       GData^ := ReadData(_Data,_data_Data,nil);
       _hi_CreateEvent(_Data,@_event_onValue,GData^);
    end
  else _hi_CreateEvent(_Data,@_event_onValue,dt);
end;

procedure ThiGlobalVarEx._work_doName;
var
  i:integer;
  nname:string;
begin
  nname := LowerCase(ToString(_Data));
  if nName <> '' then
   begin
    if Find(FName,i) then
     NList.Items[i] := nName
    else if not Find(nName,i) then
     begin
       AddName(nName);
       //_debug(nName);
     end
    else GData := PData(NList.Objects[i]);
    FName := nName;
   end;
end;

procedure ThiGlobalVarEx._var_Var;
var dt:TData;
begin
  dtNull(_Data);
  dt:= ReadData(_Data,_data_Data,nil);
  if (GData <> nil) and (not _IsNull(GData^)) then
     _Data := GData^
  else if not _IsNull(dt) then
     _Data := dt
  else
     dtNull(_Data);
end;

end.
